<a id="types-aiobotocore-datazone"></a>

# types-aiobotocore-datazone

[![PyPI - types-aiobotocore-datazone](https://img.shields.io/pypi/v/types-aiobotocore-datazone.svg?color=blue)](https://pypi.org/project/types-aiobotocore-datazone)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-datazone.svg?color=blue)](https://pypi.org/project/types-aiobotocore-datazone)
[![Docs](https://img.shields.io/readthedocs/types-aiobotocore.svg?color=blue)](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_datazone/)
[![PyPI - Downloads](https://static.pepy.tech/badge/types-aiobotocore-datazone)](https://pepy.tech/project/types-aiobotocore-datazone)

![boto3.typed](https://github.com/youtype/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[aiobotocore.DataZone 2.11.2](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/datazone.html#DataZone)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 7.23.1](https://github.com/youtype/mypy_boto3_builder).

More information can be found on
[types-aiobotocore](https://pypi.org/project/types-aiobotocore/) page and in
[types-aiobotocore-datazone docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_datazone/).

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/youtype/mypy_boto3_builder/raw/main/demo.gif)

- [types-aiobotocore-datazone](#types-aiobotocore-datazone)
  - [How to install](#how-to-install)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [How to uninstall](#how-to-uninstall)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Emacs](#emacs)
    - [Sublime Text](#sublime-text)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Type definitions](#type-definitions)
  - [How it works](#how-it-works)
  - [What's new](#what's-new)
    - [Implemented features](#implemented-features)
    - [Latest changes](#latest-changes)
  - [Versioning](#versioning)
  - [Thank you](#thank-you)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `DataZone` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[datazone]'


# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[datazone]'


# standalone installation
python -m pip install types-aiobotocore-datazone
```

<a id="how-to-uninstall"></a>

## How to uninstall

```bash
python -m pip uninstall -y types-aiobotocore-datazone
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[datazone]` in your environment:

```bash
python -m pip install 'types-aiobotocore[datazone]'
```

Both type checking and code completion should now work. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pycharm"></a>

### PyCharm

Install `types-aiobotocore-lite[datazone]` in your environment:

```bash
python -m pip install 'types-aiobotocore-lite[datazone]'`
```

Both type checking and code completion should now work. Explicit type
annotations **are required**.

Use `types-aiobotocore` package instead for implicit type discovery.

<a id="emacs"></a>

### Emacs

- Install `types-aiobotocore` with services you use in your environment:

```bash
python -m pip install 'types-aiobotocore[datazone]'
```

- Install [use-package](https://github.com/jwiegley/use-package),
  [lsp](https://github.com/emacs-lsp/lsp-mode/),
  [company](https://github.com/company-mode/company-mode) and
  [flycheck](https://github.com/flycheck/flycheck) packages
- Install [lsp-pyright](https://github.com/emacs-lsp/lsp-pyright) package

```elisp
(use-package lsp-pyright
  :ensure t
  :hook (python-mode . (lambda ()
                          (require 'lsp-pyright)
                          (lsp)))  ; or lsp-deferred
  :init (when (executable-find "python3")
          (setq lsp-pyright-python-executable-cmd "python3"))
  )
```

- Make sure emacs uses the environment where you have installed
  `types-aiobotocore`

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="sublime-text"></a>

### Sublime Text

- Install `types-aiobotocore[datazone]` with services you use in your
  environment:

```bash
python -m pip install 'types-aiobotocore[datazone]'
```

- Install [LSP-pyright](https://github.com/sublimelsp/LSP-pyright) package

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[datazone]` in your environment:

```bash
python -m pip install 'types-aiobotocore[datazone]'`
```

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `npm i -g pyright`
- Install `types-aiobotocore[datazone]` in your environment:

```bash
python -m pip install 'types-aiobotocore[datazone]'
```

Optionally, you can install `types-aiobotocore` to `typings` folder.

Type checking should now work. No explicit type annotations required, write
your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`DataZoneClient` provides annotations for `session.create_client("datazone")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_datazone import DataZoneClient

session = get_session()
async with session.create_client("datazone") as client:
    client: DataZoneClient
    # now client usage is checked by mypy and IDE should provide code completion
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_datazone.paginator` module contains type annotations for all
paginators.

```python
from aiobotocore.session import get_session

from types_aiobotocore_datazone import DataZoneClient
from types_aiobotocore_datazone.paginator import (
    ListAssetRevisionsPaginator,
    ListDataSourceRunActivitiesPaginator,
    ListDataSourceRunsPaginator,
    ListDataSourcesPaginator,
    ListDomainsPaginator,
    ListEnvironmentBlueprintConfigurationsPaginator,
    ListEnvironmentBlueprintsPaginator,
    ListEnvironmentProfilesPaginator,
    ListEnvironmentsPaginator,
    ListNotificationsPaginator,
    ListProjectMembershipsPaginator,
    ListProjectsPaginator,
    ListSubscriptionGrantsPaginator,
    ListSubscriptionRequestsPaginator,
    ListSubscriptionTargetsPaginator,
    ListSubscriptionsPaginator,
    SearchPaginator,
    SearchGroupProfilesPaginator,
    SearchListingsPaginator,
    SearchTypesPaginator,
    SearchUserProfilesPaginator,
)

session = get_session()
async with session.create_client("datazone") as client:
    client: DataZoneClient

    # Explicit type annotations are optional here
    # Types should be correctly discovered by mypy and IDEs
    list_asset_revisions_paginator: ListAssetRevisionsPaginator = client.get_paginator(
        "list_asset_revisions"
    )
    list_data_source_run_activities_paginator: ListDataSourceRunActivitiesPaginator = (
        client.get_paginator("list_data_source_run_activities")
    )
    list_data_source_runs_paginator: ListDataSourceRunsPaginator = client.get_paginator(
        "list_data_source_runs"
    )
    list_data_sources_paginator: ListDataSourcesPaginator = client.get_paginator(
        "list_data_sources"
    )
    list_domains_paginator: ListDomainsPaginator = client.get_paginator("list_domains")
    list_environment_blueprint_configurations_paginator: (
        ListEnvironmentBlueprintConfigurationsPaginator
    ) = client.get_paginator("list_environment_blueprint_configurations")
    list_environment_blueprints_paginator: ListEnvironmentBlueprintsPaginator = (
        client.get_paginator("list_environment_blueprints")
    )
    list_environment_profiles_paginator: ListEnvironmentProfilesPaginator = client.get_paginator(
        "list_environment_profiles"
    )
    list_environments_paginator: ListEnvironmentsPaginator = client.get_paginator(
        "list_environments"
    )
    list_notifications_paginator: ListNotificationsPaginator = client.get_paginator(
        "list_notifications"
    )
    list_project_memberships_paginator: ListProjectMembershipsPaginator = client.get_paginator(
        "list_project_memberships"
    )
    list_projects_paginator: ListProjectsPaginator = client.get_paginator("list_projects")
    list_subscription_grants_paginator: ListSubscriptionGrantsPaginator = client.get_paginator(
        "list_subscription_grants"
    )
    list_subscription_requests_paginator: ListSubscriptionRequestsPaginator = client.get_paginator(
        "list_subscription_requests"
    )
    list_subscription_targets_paginator: ListSubscriptionTargetsPaginator = client.get_paginator(
        "list_subscription_targets"
    )
    list_subscriptions_paginator: ListSubscriptionsPaginator = client.get_paginator(
        "list_subscriptions"
    )
    search_paginator: SearchPaginator = client.get_paginator("search")
    search_group_profiles_paginator: SearchGroupProfilesPaginator = client.get_paginator(
        "search_group_profiles"
    )
    search_listings_paginator: SearchListingsPaginator = client.get_paginator("search_listings")
    search_types_paginator: SearchTypesPaginator = client.get_paginator("search_types")
    search_user_profiles_paginator: SearchUserProfilesPaginator = client.get_paginator(
        "search_user_profiles"
    )
```

<a id="literals"></a>

### Literals

`types_aiobotocore_datazone.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

Full list of `DataZone` Literals can be found in
[docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_datazone/literals/).

```python
from types_aiobotocore_datazone.literals import AcceptRuleBehaviorType


def check_value(value: AcceptRuleBehaviorType) -> bool: ...
```

<a id="type-definitions"></a>

### Type definitions

`types_aiobotocore_datazone.type_defs` module contains structures and shapes
assembled to typed dictionaries and unions for additional type checking.

Full list of `DataZone` TypeDefs can be found in
[docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_datazone/type_defs/).

```python
from types_aiobotocore_datazone.type_defs import AcceptChoiceTypeDef


def get_value() -> AcceptChoiceTypeDef:
    return {...}
```

<a id="how-it-works"></a>

## How it works

Fully automated
[mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder) carefully
generates type annotations for each service, patiently waiting for
`aiobotocore` updates. It delivers drop-in type annotations for you and makes
sure that:

- All available `aiobotocore` services are covered.
- Each public class and method of every `aiobotocore` service gets valid type
  annotations extracted from `botocore` schemas.
- Type annotations include up-to-date documentation.
- Link to documentation is provided for every method.
- Code is processed by [black](https://github.com/psf/black) and
  [isort](https://github.com/PyCQA/isort) for readability.

<a id="what's-new"></a>

## What's new

<a id="implemented-features"></a>

### Implemented features

- Fully type annotated `boto3`, `botocore`, `aiobotocore` and `aioboto3`
  libraries
- `mypy`, `pyright`, `VSCode`, `PyCharm`, `Sublime Text` and `Emacs`
  compatibility
- `Client`, `ServiceResource`, `Resource`, `Waiter` `Paginator` type
  annotations for each service
- Generated `TypeDefs` for each service
- Generated `Literals` for each service
- Auto discovery of types for `boto3.client` and `boto3.resource` calls
- Auto discovery of types for `session.client` and `session.resource` calls
- Auto discovery of types for `client.get_waiter` and `client.get_paginator`
  calls
- Auto discovery of types for `ServiceResource` and `Resource` collections
- Auto discovery of types for `aiobotocore.Session.create_client` calls

<a id="latest-changes"></a>

### Latest changes

Builder changelog can be found in
[Releases](https://github.com/youtype/mypy_boto3_builder/releases).

<a id="versioning"></a>

## Versioning

`types-aiobotocore-datazone` version is the same as related `aiobotocore`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

<a id="thank-you"></a>

## Thank you

- [Allie Fitter](https://github.com/alliefitter) for
  [boto3-type-annotations](https://pypi.org/project/boto3-type-annotations/),
  this package is based on top of his work
- [black](https://github.com/psf/black) developers for an awesome formatting
  tool
- [Timothy Edmund Crosley](https://github.com/timothycrosley) for
  [isort](https://github.com/PyCQA/isort) and how flexible it is
- [mypy](https://github.com/python/mypy) developers for doing all dirty work
  for us
- [pyright](https://github.com/microsoft/pyright) team for the new era of typed
  Python

<a id="documentation"></a>

## Documentation

All services type annotations can be found in
[aiobotocore docs](https://youtype.github.io/types_aiobotocore_docs/types_aiobotocore_datazone/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/youtype/mypy_boto3_builder/issues/)
repository.
